#INCLUDE "dcdialog.CH"

FUNCTION Main()

LOCAL Getlist[0], aDir, oBrowse

aDir := Directory()

@ 0,0 DCBROWSE oBrowse DATA aDir SIZE 20,20 FIT

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'File Size' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'File Date' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'File Time' WIDTH 10 PARENT oBrowse

@ 22,0 DCPUSHBUTTON CAPTION 'Create Dbf' SIZE 10 ;
   ACTION {||CreateDbf(oBrowse)}

DCREAD GUI FIT ADDBUTTONS TITLE 'Testing DC_Browse2Dbf()'

RETURN Nil

* -----------

PROC appsys ; RETURN

* -----------

FUNCTION CreateDbf( oBrowse )

LOCAL aStru := { ;
   { 'FILE_NAME','C',30,0}, ;
   { 'FILE_SIZE','N', 9,0}, ;
   { 'FILE_DATE','D', 8,0}, ;
   { 'FILE_TIME','C',10,0} ;
   }

DC_Browse2Dbf( oBrowse, 'DIRECTORY.DBF', aStru )

RETURN nil

* -----------

FUNCTION DC_Browse2Dbf( oBrowse, cDbfName, aStru )

LOCAL oColumn, aColumns, i, nRecord, nPreviousRecord, xValue, lStatus := .t., ;
      cFieldType, cFieldName, cAlias

IF Valtype(oBrowse:dataSource) = 'C'
  nPreviousRecord := (oBrowse:dataSource)->(RecNo())
  oBrowse:stableblock := {||nRecord := (oBrowse:dataSource)->(RecNo())}
ELSEIF Valtype(oBrowse:dataSource) = 'A'
  nPreviousRecord := oBrowse:arrayElement
  oBrowse:stableblock := {||nRecord := oBrowse:arrayElement}
ELSE
  RETURN .f.
ENDIF

aColumns := Array(oBrowse:colCount)

IF Len(aStru) # Len(aColumns)
  RETURN .f.
ENDIF

dbCreate( cDbfName, aStru )
USE (cDbfName) NEW
cAlias := Alias()

oBrowse:goTop()

FOR i := 1 TO Len(aColumns)
  oColumn := oBrowse:getColumn(i)
  aColumns[i]   := oColumn
NEXT

DO WHILE .t.

  (cAlias)->(DC_AddRec())

  FOR i := 1 TO Len(aColumns)
    xValue := Eval(aColumns[i]:dataLink)
    cFieldName := aStru[i,1]
    cFieldType := aStru[i,2]
    IF !(Valtype(xValue) == cFieldType)
      IF cFieldType == 'N' .AND. Valtype(xValue) == 'C'
        xValue := Val(xValue)
      ELSEIF cFieldType == 'D' .AND. Valtype(xValue) == 'C'
        xValue := Ctod(xValue)
      ELSEIF cFieldType = 'C'
        xValue := DC_XtoC(xValue)
      ENDIF
    ENDIF
    REPLACE (cAlias)->&(cFieldName) WITH xValue
  NEXT
  (cAlias)->(dbRUnlock())

  oBrowse:down()
  oBrowse:forcestable()
  IF nRecord == nPreviousrecord
    EXIT
  ENDIF
  nPreviousrecord := nRecord

ENDDO

RETURN lStatus


